=begin
#KORONA.entry API v1

#Our api provides access to our entry services

The version of the OpenAPI document: 1.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.0

=end

require 'date'

module KoronaEntryClient
  # The external ticket configuration.
  class ExternalTicketConfiguration
    # Objects ID.
    attr_accessor :id

    # Number of external ticket configuration.
    attr_accessor :number

    # Name of external ticket configuration.
    attr_accessor :name

    # Matching pattern for unkown external tickets.
    attr_accessor :pattern

    # Adjusts the validFrom value of TicketEntry while ticket creation dynamically to the ticket creation time plus the period.
    attr_accessor :valid_from_period

    # Adjusts the validTo value of TicketEntry while ticket creation dynamically to the ticket creation time plus the period.
    attr_accessor :valid_to_period

    # Validities for this configuration of external tickets.
    attr_accessor :ticket_entries

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'number' => :'number',
        :'name' => :'name',
        :'pattern' => :'pattern',
        :'valid_from_period' => :'validFromPeriod',
        :'valid_to_period' => :'validToPeriod',
        :'ticket_entries' => :'ticketEntries'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'Integer',
        :'number' => :'String',
        :'name' => :'String',
        :'pattern' => :'String',
        :'valid_from_period' => :'String',
        :'valid_to_period' => :'String',
        :'ticket_entries' => :'Array<TicketEntry>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `KoronaEntryClient::ExternalTicketConfiguration` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `KoronaEntryClient::ExternalTicketConfiguration`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'number')
        self.number = attributes[:'number']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'pattern')
        self.pattern = attributes[:'pattern']
      end

      if attributes.key?(:'valid_from_period')
        self.valid_from_period = attributes[:'valid_from_period']
      end

      if attributes.key?(:'valid_to_period')
        self.valid_to_period = attributes[:'valid_to_period']
      end

      if attributes.key?(:'ticket_entries')
        if (value = attributes[:'ticket_entries']).is_a?(Array)
          self.ticket_entries = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      pattern = Regexp.new(/^(-?)P(?=.)((\d+)Y)?((\d+)M)?((\d+)D)?(T(?=.)((\d+)H)?((\d+)M)?(\d*(\.\d+)?S)?)?$/)
      if !@valid_from_period.nil? && @valid_from_period !~ pattern
        invalid_properties.push("invalid value for \"valid_from_period\", must conform to the pattern #{pattern}.")
      end

      pattern = Regexp.new(/^(-?)P(?=.)((\d+)Y)?((\d+)M)?((\d+)D)?(T(?=.)((\d+)H)?((\d+)M)?(\d*(\.\d+)?S)?)?$/)
      if !@valid_to_period.nil? && @valid_to_period !~ pattern
        invalid_properties.push("invalid value for \"valid_to_period\", must conform to the pattern #{pattern}.")
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@valid_from_period.nil? && @valid_from_period !~ Regexp.new(/^(-?)P(?=.)((\d+)Y)?((\d+)M)?((\d+)D)?(T(?=.)((\d+)H)?((\d+)M)?(\d*(\.\d+)?S)?)?$/)
      return false if !@valid_to_period.nil? && @valid_to_period !~ Regexp.new(/^(-?)P(?=.)((\d+)Y)?((\d+)M)?((\d+)D)?(T(?=.)((\d+)H)?((\d+)M)?(\d*(\.\d+)?S)?)?$/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] valid_from_period Value to be assigned
    def valid_from_period=(valid_from_period)
      pattern = Regexp.new(/^(-?)P(?=.)((\d+)Y)?((\d+)M)?((\d+)D)?(T(?=.)((\d+)H)?((\d+)M)?(\d*(\.\d+)?S)?)?$/)
      if !valid_from_period.nil? && valid_from_period !~ pattern
        fail ArgumentError, "invalid value for \"valid_from_period\", must conform to the pattern #{pattern}."
      end

      @valid_from_period = valid_from_period
    end

    # Custom attribute writer method with validation
    # @param [Object] valid_to_period Value to be assigned
    def valid_to_period=(valid_to_period)
      pattern = Regexp.new(/^(-?)P(?=.)((\d+)Y)?((\d+)M)?((\d+)D)?(T(?=.)((\d+)H)?((\d+)M)?(\d*(\.\d+)?S)?)?$/)
      if !valid_to_period.nil? && valid_to_period !~ pattern
        fail ArgumentError, "invalid value for \"valid_to_period\", must conform to the pattern #{pattern}."
      end

      @valid_to_period = valid_to_period
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          number == o.number &&
          name == o.name &&
          pattern == o.pattern &&
          valid_from_period == o.valid_from_period &&
          valid_to_period == o.valid_to_period &&
          ticket_entries == o.ticket_entries
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [id, number, name, pattern, valid_from_period, valid_to_period, ticket_entries].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        KoronaEntryClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
